From a464c80f1806580174272b49855fce569cfd90f7 Mon Sep 17 00:00:00 2001
From: Simon Hausmann <simon.hausmann@qt.io>
Date: Thu, 29 Jun 2017 15:09:51 +0200
Subject: [PATCH] Fix memory of QML type registry not freed when
 clearing/trimming QML component cache

Task-number: QTBUG-61536

Squashed commit of the following:

commit e886def3ab5bd1c4ed4dba214d8161d1e37d948d
Author: Simon Hausmann <simon.hausmann@qt.io>
Date:   Thu Jun 29 14:56:05 2017 +0200

    Reduce memory consumption of stat() cache in QML type loader

    The m_importDirCache caches the result of QDir/File::exists across
    paths. By changing the data structure to a QCache we impose a limit on
    the size of the entries and thus the memory consumption for long running
    programs that access many qml files.

    Change-Id: I20c4dc77260fe353c13da570b7e1bbd3f47d4b79

commit 382e3c1b16470791acb2e246ecb1b4b2efa888da
Author: Simon Hausmann <simon.hausmann@qt.io>
Date:   Wed Jun 28 11:25:18 2017 +0200

    Improve releasing of memory allocated from compilation unit strings

    Allocate the strings in the compilation unit as regular strings, not as
    identifiers. We mark the runtimeStrings in the compilation unit, so when
    the unit is released as part of component cache trimming, those strings
    can also be collected. The JS object literal class keys have to remain
    identifiers though.

    However this is just a stop-gap as the real problem is that the
    identifier table can be triggered to grow without bounds.

    Change-Id: I7a2854b7fa9c9953348b5e34a31833f7be67cfbf

commit fbc73cf1934a3246777823c9187cf24fcfc56437
Author: Lars Knoll <lars.knoll@qt.io>
Date:   Mon Jun 26 11:49:34 2017 +0200

    Fix void * usage in our internal APIs

    Change-Id: Ia2b5cfeab093d8be91728032528788dd238c2872

commit 62c99c0dfb0864c0fc0a281ae2e11b7ff6b8959d
Author: Lars Knoll <lars.knoll@qt.io>
Date:   Tue Jun 27 08:55:01 2017 +0200

    Move the m_qmlLists member in the QML engine to QQmlMetaType

    This is a pure metatype id to metatype id mapping, nothing
    in there is specific to a QML engine instance. Thus move the
    mapping to QQmlMetaType and make it global for all engines.

    Change-Id: I3792567bc9f585e3e0fbbad94efd1ec3a0db3de0

commit 39aa48b31f5ed71a07faa11e08a578b1f6322499
Author: Simon Hausmann <simon.hausmann@qt.io>
Date:   Mon Jun 26 14:52:22 2017 +0200

    Remove unused types on engine destruction

    The QML engine destructor as well as trimComponentCache()
    do now clean out unused composite types that the engine
    registered internally.

    This helps avoid 'static' leaks, when more and more types
    would get registered by the engine.

    Change-Id: I5b32af4b88fbf626de8c0bfbaedb2285b09e3679

commit ada481758f54837644be034775eb8fe993d8a42c
Author: Simon Hausmann <simon.hausmann@qt.io>
Date:   Mon Jun 26 14:28:57 2017 +0200

    Remove unused variable

    Change-Id: Ia7af542e6969c167d1f05a460e0926398f56f380
    QQmlTypeModulePrivate::types is not used (anymore?).

commit 644dd15125930884826fc777d7ed316f8543737c
Author: Lars Knoll <lars.knoll@qt.io>
Date:   Mon Jun 26 13:45:56 2017 +0200

    Change data structures in QQmlMetaTypeData

    Make sure any QQmlType stored in the meta type data
    has a refcount of 1. This should now make it possible
    to clean out unused types by iterating over the
    list of types and removing those that have a refcount
    of 1.

    Some care is still needed for C++ registered types, that
    will need to get one more refcount, so we don't accidentally
    remove them.

    Change-Id: Id2a18dae5ddcb815f34013f5fde1f05d2d9d0214

commit c6b45e0c4dc9a2879934d7898cba94c0384a3be7
Author: Simon Hausmann <simon.hausmann@qt.io>
Date:   Fri Jun 23 17:19:26 2017 +0200

    Remove QQmlEnginePrivate::typePropertyCache

    Instead of maintaining a hash per QQmlType and minor version, move the
    version specific property caches into QQmlType.

    Change-Id: I72f3990cb93e64ac5074060b4ff327043eab7966

commit 73c5d915ba92f8a3b05fc05e35b160a7032a2f35
Author: Simon Hausmann <simon.hausmann@qt.io>
Date:   Fri Jun 23 13:36:13 2017 +0200

    Move property cache from the engine to QQmlType

    Now that the property cache is independent of a specific
    engine, we can cache them in QQmlType instead of caching
    them per engine.

    This simplifies the logic and avoids duplicated property
    caches when multiple engines are running.

    Change-Id: I6f082e1e7495ae0f5b92559e8d0a3437c56e303a

commit a46c9ad88169a8380cc1269d17ada1bf01e96ff7
Author: Lars Knoll <lars.knoll@qt.io>
Date:   Fri Jun 23 12:10:23 2017 +0200

    Move the engine pointer from the property cache to the VME meta object

    This is where it belongs, and it makes the PropertyCache independent
    of the engine used.

    Change-Id: I21c2674ee3e2895abd2418764d140b154b47b868

commit b5a158ee99806410f48bc9ccc9b31320fe8ee7b7
Author: Lars Knoll <lars.knoll@qt.io>
Date:   Fri Jun 23 13:20:23 2017 +0200

    Use QQmlType by value

    QQmlType is now refcounted, and we need to use it by
    value, to control it's lifetime properly. This is
    required, so we can clean up the QQmlMetaTypeData
    cache on engine destruction and with trimComponentCache()

    Change-Id: If86391c86ea20a646ded7c9925d8f743f628fb91

commit 3ec22677e0a1f1308edf04996474dc7d35985e0b
Author: Lars Knoll <lars.knoll@qt.io>
Date:   Fri Jun 23 13:38:43 2017 +0200

    Simplify logic

    Change-Id: Ibdb10dfb8d9fbd15fddc27a2802b756381755ee7

commit c9f761529c535a09fc0d59d8f81037de0104d0de
Author: Lars Knoll <lars.knoll@qt.io>
Date:   Fri Jun 23 13:09:03 2017 +0200

    Use QQmlType by value in the type wrapper

    Change-Id: Ie40cb3a6e170331b0ec7ab5deaf7c1d7ef0cdaeb

commit ac3b35ee606b7ca85ccd81e13fd2609108912812
Author: Lars Knoll <lars.knoll@qt.io>
Date:   Fri Jun 23 10:41:21 2017 +0200

    Use QQmlType by value in the MemberExpressionResolver

    Change-Id: Ia9a43890937399f3a109d93227e5d44420974737

commit 13eea2d8dac09a8058a6438fcd70e09b4342a499
Author: Lars Knoll <lars.knoll@qt.io>
Date:   Fri Jun 23 10:40:55 2017 +0200

    Turn QQmlType into a refcounted value type

    Change-Id: If906af2bf3afd09c23a612aaac417a751b06eba4

commit 1bfc4fc8ef9a3c599e674e7ddb9b093d8d657969
Author: Simon Hausmann <simon.hausmann@qt.io>
Date:   Tue Jun 27 15:01:44 2017 +0200

    Fix bug in designer support reference counting

    The QtQuick designer support may override the meta-object and reparent the
    property-cache of the object under editing. The code for replacing the parent
    of the property cache however was not handling the refcount of the _parent
    correctly.

    Change-Id: Ic73294fc208b297e8ec9c0b775b5da01a309dba6
    Reviewed-by: Robin Burchell <robin.burchell@viroteck.net>
    (cherry picked from commit 7dc5cd942eb5c55a26d539eedff48b2d6c8e0fc3)

commit be40ab67dd4ce2296c113725d53feedc5183c7f6
Author: Colin Ogilvie <colin.ogilvie@kdab.com>
Date:   Fri Jun 2 11:37:09 2017 +0100

    Don't leak QQmlJavaScriptExpression errors

    Ensure any error is deleted when the expression is

    Change-Id: Ibbfd28f50279d4c66830b40c5c917eb8d98f266e
    Reviewed-by: Simon Hausmann <simon.hausmann@qt.io>
    (cherry picked from commit 1e0685136d0debb2a3b62d9f4650c95afe41913b)

Change-Id: I1d0a15b263a7315d372e4c145e35d22fadf2512a
---
 src/imports/testlib/main.cpp                       |   8 +-
 .../qmldbg_debugger/qqmlenginedebugservice.cpp     |  11 +-
 src/qml/compiler/qqmlirbuilder.cpp                 |  44 +-
 src/qml/compiler/qqmltypecompiler.cpp              | 131 ++-
 src/qml/compiler/qv4compileddata.cpp               |   5 +-
 src/qml/compiler/qv4jsir_p.h                       |  15 +-
 src/qml/jsapi/qjsengine.cpp                        |  19 +-
 src/qml/jsapi/qjsengine_p.h                        |  17 +-
 src/qml/jsruntime/qv4engine.cpp                    |   6 +-
 src/qml/jsruntime/qv4function.cpp                  |   7 +-
 src/qml/jsruntime/qv4lookup.cpp                    |   5 +-
 src/qml/jsruntime/qv4qobjectwrapper.cpp            |   5 +-
 src/qml/qml/qqmlcompileddata.cpp                   |  10 +-
 src/qml/qml/qqmlcompiler_p.h                       |   4 +-
 src/qml/qml/qqmlcontextwrapper.cpp                 |   2 +-
 src/qml/qml/qqmlcustomparser.cpp                   |  10 +-
 src/qml/qml/qqmlengine.cpp                         | 181 +---
 src/qml/qml/qqmlengine_p.h                         |  19 +-
 src/qml/qml/qqmlimport.cpp                         |  84 +-
 src/qml/qml/qqmlimport_p.h                         |   8 +-
 src/qml/qml/qqmljavascriptexpression.cpp           |   1 +
 src/qml/qml/qqmllist.cpp                           |   2 +-
 src/qml/qml/qqmlmetatype.cpp                       | 934 +++++++++++++++------
 src/qml/qml/qqmlmetatype_p.h                       | 108 ++-
 src/qml/qml/qqmlobjectcreator.cpp                  |  36 +-
 src/qml/qml/qqmlopenmetaobject.cpp                 |   2 +-
 src/qml/qml/qqmlproperty.cpp                       |  25 +-
 src/qml/qml/qqmlpropertycache.cpp                  |  47 +-
 src/qml/qml/qqmlpropertycache_p.h                  |  18 +-
 src/qml/qml/qqmltypeloader.cpp                     |  67 +-
 src/qml/qml/qqmltypeloader_p.h                     |   8 +-
 src/qml/qml/qqmltypenamecache.cpp                  |  29 +-
 src/qml/qml/qqmltypenamecache_p.h                  |  73 +-
 src/qml/qml/qqmltypewrapper.cpp                    |  54 +-
 src/qml/qml/qqmltypewrapper_p.h                    |   8 +-
 src/qml/qml/qqmlvmemetaobject.cpp                  |  71 +-
 src/qml/qml/qqmlvmemetaobject_p.h                  |   3 +-
 src/qml/types/qqmldelegatemodel.cpp                |   6 +-
 src/qml/util/qqmladaptormodel.cpp                  |  15 +-
 src/qml/util/qqmladaptormodel_p.h                  |   5 +-
 src/quick/designer/qqmldesignermetaobject.cpp      |   2 +-
 src/quick/designer/qquickdesignersupportitems.cpp  |  41 +-
 .../designer/qquickdesignersupportmetainfo.cpp     |   4 +-
 .../tst_qqmlenginedebugservice.cpp                 |   4 +-
 tests/auto/qml/qqmlmetatype/tst_qqmlmetatype.cpp   | 104 +--
 .../qqmlpropertycache/tst_qqmlpropertycache.cpp    |  18 +-
 tests/benchmarks/qml/creation/tst_creation.cpp     |   4 +-
 tools/qmlplugindump/main.cpp                       | 126 +--
 48 files changed, 1305 insertions(+), 1101 deletions(-)

diff --git a/src/imports/testlib/main.cpp b/src/imports/testlib/main.cpp
index b90c671cb..8e410ef97 100644
--- a/src/imports/testlib/main.cpp
+++ b/src/imports/testlib/main.cpp
@@ -78,14 +78,14 @@ public Q_SLOTS:
     {
         QString name(v.typeName());
         if (v.canConvert<QObject*>()) {
-            QQmlType *type = 0;
+            QQmlType type;
             const QMetaObject *mo = v.value<QObject*>()->metaObject();
-            while (!type && mo) {
+            while (!type.isValid() && mo) {
                 type = QQmlMetaType::qmlType(mo);
                 mo = mo->superClass();
             }
-            if (type) {
-                name = type->qmlTypeName();
+            if (type.isValid()) {
+                name = type.qmlTypeName();
             }
         }
 
diff --git a/src/plugins/qmltooling/qmldbg_debugger/qqmlenginedebugservice.cpp b/src/plugins/qmltooling/qmldbg_debugger/qqmlenginedebugservice.cpp
index 8f53dc6d5..376461b9f 100644
--- a/src/plugins/qmltooling/qmldbg_debugger/qqmlenginedebugservice.cpp
+++ b/src/plugins/qmltooling/qmldbg_debugger/qqmlenginedebugservice.cpp
@@ -397,9 +397,9 @@ QQmlEngineDebugServiceImpl::objectData(QObject *object)
     rv.objectId = QQmlDebugService::idForObject(object);
     rv.contextId = QQmlDebugService::idForObject(qmlContext(object));
     rv.parentId = QQmlDebugService::idForObject(object->parent());
-    QQmlType *type = QQmlMetaType::qmlType(object->metaObject());
-    if (type) {
-        QString typeName = type->qmlTypeName();
+    QQmlType type = QQmlMetaType::qmlType(object->metaObject());
+    if (type.isValid()) {
+        QString typeName = type.qmlTypeName();
         int lastSlash = typeName.lastIndexOf(QLatin1Char('/'));
         rv.objectType = lastSlash < 0 ? typeName : typeName.mid(lastSlash+1);
     } else {
@@ -693,8 +693,9 @@ bool QQmlEngineDebugServiceImpl::resetBinding(int objectId, const QString &prope
                 property.reset();
             } else {
                 // overwrite with default value
-                if (QQmlType *objType = QQmlMetaType::qmlType(object->metaObject())) {
-                    if (QObject *emptyObject = objType->create()) {
+                QQmlType objType = QQmlMetaType::qmlType(object->metaObject());
+                if (objType.isValid()) {
+                    if (QObject *emptyObject = objType.create()) {
                         if (emptyObject->property(parentProperty.toLatin1()).isValid()) {
                             QVariant defaultValue = QQmlProperty(emptyObject, propertyName).read();
                             if (defaultValue.isValid()) {
diff --git a/src/qml/compiler/qqmlirbuilder.cpp b/src/qml/compiler/qqmlirbuilder.cpp
index 791355a66..5a6c65362 100644
--- a/src/qml/compiler/qqmlirbuilder.cpp
+++ b/src/qml/compiler/qqmlirbuilder.cpp
@@ -1586,11 +1586,11 @@ static QV4::IR::Type resolveQmlType(QQmlEnginePrivate *qmlEngine, QV4::IR::Membe
 {
     QV4::IR::Type result = QV4::IR::VarType;
 
-    QQmlType *type = static_cast<QQmlType*>(resolver->data);
+    QQmlType type = resolver->qmlType;
 
     if (member->name->constData()->isUpper()) {
         bool ok = false;
-        int value = type->enumValue(qmlEngine, *member->name, &ok);
+        int value = type.enumValue(qmlEngine, *member->name, &ok);
         if (ok) {
             member->setEnumValue(value);
             resolver->clear();
@@ -1598,8 +1598,8 @@ static QV4::IR::Type resolveQmlType(QQmlEnginePrivate *qmlEngine, QV4::IR::Membe
         }
     }
 
-    if (type->isCompositeSingleton()) {
-        QQmlRefPointer<QQmlTypeData> tdata = qmlEngine->typeLoader.getType(type->singletonInstanceInfo()->url);
+    if (type.isCompositeSingleton()) {
+        QQmlRefPointer<QQmlTypeData> tdata = qmlEngine->typeLoader.getType(type.singletonInstanceInfo()->url);
         Q_ASSERT(tdata);
         tdata->release(); // Decrease the reference count added from QQmlTypeLoader::getType()
         // When a singleton tries to reference itself, it may not be complete yet.
@@ -1608,17 +1608,17 @@ static QV4::IR::Type resolveQmlType(QQmlEnginePrivate *qmlEngine, QV4::IR::Membe
             resolver->flags |= AllPropertiesAreFinal;
             return resolver->resolveMember(qmlEngine, resolver, member);
         }
-    }  else if (type->isSingleton()) {
-        const QMetaObject *singletonMeta = type->singletonInstanceInfo()->instanceMetaObject;
+    }  else if (type.isSingleton()) {
+        const QMetaObject *singletonMeta = type.singletonInstanceInfo()->instanceMetaObject;
         if (singletonMeta) { // QJSValue-based singletons cannot be accelerated
             initMetaObjectResolver(resolver, qmlEngine->cache(singletonMeta));
             member->kind = QV4::IR::Member::MemberOfSingletonObject;
             return resolver->resolveMember(qmlEngine, resolver, member);
         }
-    } else if (const QMetaObject *attachedMeta = type->attachedPropertiesType(qmlEngine)) {
+    } else if (const QMetaObject *attachedMeta = type.attachedPropertiesType(qmlEngine)) {
         QQmlPropertyCache *cache = qmlEngine->cache(attachedMeta);
         initMetaObjectResolver(resolver, cache);
-        member->setAttachedPropertiesId(type->attachedPropertiesId(qmlEngine));
+        member->setAttachedPropertiesId(type.attachedPropertiesId(qmlEngine));
         return resolver->resolveMember(qmlEngine, resolver, member);
     }
 
@@ -1626,21 +1626,21 @@ static QV4::IR::Type resolveQmlType(QQmlEnginePrivate *qmlEngine, QV4::IR::Membe
     return result;
 }
 
-static void initQmlTypeResolver(QV4::IR::MemberExpressionResolver *resolver, QQmlType *qmlType)
+static void initQmlTypeResolver(QV4::IR::MemberExpressionResolver *resolver, const QQmlType &qmlType)
 {
     Q_ASSERT(resolver);
 
     resolver->resolveMember = &resolveQmlType;
-    resolver->data = qmlType;
-    resolver->extraData = 0;
+    resolver->qmlType = qmlType;
+    resolver->typenameCache = 0;
     resolver->flags = 0;
 }
 
 static QV4::IR::Type resolveImportNamespace(QQmlEnginePrivate *, QV4::IR::MemberExpressionResolver *resolver, QV4::IR::Member *member)
 {
     QV4::IR::Type result = QV4::IR::VarType;
-    QQmlTypeNameCache *typeNamespace = static_cast<QQmlTypeNameCache*>(resolver->extraData);
-    void *importNamespace = resolver->data;
+    QQmlTypeNameCache *typeNamespace = resolver->typenameCache;
+    const QQmlImportRef *importNamespace = resolver->import;
 
     QQmlTypeNameCache::Result r = typeNamespace->query(*member->name, importNamespace);
     if (r.isValid()) {
@@ -1648,11 +1648,11 @@ static QV4::IR::Type resolveImportNamespace(QQmlEnginePrivate *, QV4::IR::Member
         if (r.scriptIndex != -1) {
             // TODO: remember the index and replace with subscript later.
             result = QV4::IR::VarType;
-        } else if (r.type) {
+        } else if (r.type.isValid()) {
             // TODO: Propagate singleton information, so that it is loaded
             // through the singleton getter in the run-time. Until then we
             // can't accelerate access :(
-            if (!r.type->isSingleton()) {
+            if (!r.type.isSingleton()) {
                 initQmlTypeResolver(resolver, r.type);
                 return QV4::IR::QObjectType;
             }
@@ -1665,18 +1665,18 @@ static QV4::IR::Type resolveImportNamespace(QQmlEnginePrivate *, QV4::IR::Member
     return result;
 }
 
-static void initImportNamespaceResolver(QV4::IR::MemberExpressionResolver *resolver, QQmlTypeNameCache *imports, const void *importNamespace)
+static void initImportNamespaceResolver(QV4::IR::MemberExpressionResolver *resolver, QQmlTypeNameCache *imports, const QQmlImportRef *importNamespace)
 {
     resolver->resolveMember = &resolveImportNamespace;
-    resolver->data = const_cast<void*>(importNamespace);
-    resolver->extraData = imports;
+    resolver->import = importNamespace;
+    resolver->typenameCache = imports;
     resolver->flags = 0;
 }
 
 static QV4::IR::Type resolveMetaObjectProperty(QQmlEnginePrivate *qmlEngine, QV4::IR::MemberExpressionResolver *resolver, QV4::IR::Member *member)
 {
     QV4::IR::Type result = QV4::IR::VarType;
-    QQmlPropertyCache *metaObject = static_cast<QQmlPropertyCache*>(resolver->data);
+    QQmlPropertyCache *metaObject = resolver->propertyCache;
 
     if (member->name->constData()->isUpper() && (resolver->flags & LookupsIncludeEnums)) {
         const QMetaObject *mo = metaObject->createMetaObject();
@@ -1755,7 +1755,7 @@ static void initMetaObjectResolver(QV4::IR::MemberExpressionResolver *resolver,
     Q_ASSERT(resolver);
 
     resolver->resolveMember = &resolveMetaObjectProperty;
-    resolver->data = metaObject;
+    resolver->propertyCache = metaObject;
     resolver->flags = 0;
 }
 
@@ -1814,10 +1814,10 @@ QV4::IR::Expr *JSCodeGen::fallbackNameLookup(const QString &name, int line, int
         if (r.isValid()) {
             if (r.scriptIndex != -1) {
                 return subscript(_block->TEMP(_importedScriptsTemp), _block->CONST(QV4::IR::SInt32Type, r.scriptIndex));
-            } else if (r.type) {
+            } else if (r.type.isValid()) {
                 QV4::IR::Name *typeName = _block->NAME(name, line, col);
                 // Make sure the run-time loads this through the more efficient singleton getter.
-                typeName->qmlSingleton = r.type->isCompositeSingleton();
+                typeName->qmlSingleton = r.type.isCompositeSingleton();
                 typeName->freeOfSideEffects = true;
                 QV4::IR::Temp *result = _block->TEMP(_block->newTemp());
                 _block->MOVE(result, typeName);
